Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 2797)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 2798)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Consider also default-type surfaces for surface temperature output. 
+! 
+! 2797 2018-02-08 13:24:35Z suehring
 ! Enable output of ground-heat flux also at urban surfaces.
 ! 
@@ -3368,6 +3371,5 @@
           ENDIF
 
-             IF ( ( TRIM( var ) == 'r_a*' .OR.  TRIM( var ) == 'tsurf*'  .OR.  &
-                    TRIM( var ) == 'ghf*' )                                    &
+             IF ( ( TRIM( var ) == 'r_a*' .OR.  TRIM( var ) == 'ghf*' )        &
                  .AND.  .NOT.  land_surface  .AND.  .NOT.  urban_surface )     &         
              THEN
Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 2797)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 2798)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Consider also default-type surfaces for surface temperature output. 
+! 
+! 2797 2018-02-08 13:24:35Z suehring
 ! Enable output of ground-heat flux also at urban surfaces.
 ! 
@@ -1037,4 +1040,10 @@
              CASE ( 'tsurf*_xy' )        ! 2d-array
                 IF ( av == 0 )  THEN
+                   DO  m = 1, surf_def_h(0)%ns
+                      i                   = surf_def_h(0)%i(m)            
+                      j                   = surf_def_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_def_h(0)%pt_surface(m)
+                   ENDDO
+
                    DO  m = 1, surf_lsm_h%ns
                       i                   = surf_lsm_h%i(m)            
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2797)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2798)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Minor bugfix for initialization of pt_surface
+! 
+! 2797 2018-02-08 13:24:35Z suehring
 ! Move output of ghf to general 2D output to output ghf also at urban-type 
 ! surfaces. 
@@ -4031,5 +4034,5 @@
 !--          layer
              IF ( surf_lsm_h%lambda_surface_s(m) == 0.0_wp )  THEN
-                t_surface_h%var_1d(:)    = t_soil_h%var_2d(nzb_soil,m)
+                t_surface_h%var_1d(m)    = t_soil_h%var_2d(nzb_soil,m)
                 surf_lsm_h%pt_surface(m) = t_soil_h%var_2d(nzb_soil,m) / exn
              ELSE
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 2797)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 2798)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Consider also default-type surfaces for surface temperature output. 
+! 
+! 2797 2018-02-08 13:24:35Z suehring
 ! Enable output of ground-heat flux also at urban surfaces.
 ! 
@@ -913,4 +916,10 @@
 
           CASE ( 'tsurf*' )
+             DO  m = 1, surf_def_h(0)%ns
+                i   = surf_def_h(0)%i(m)            
+                j   = surf_def_h(0)%j(m)
+                tsurf_av(j,i) = tsurf_av(j,i) + surf_def_h(0)%pt_surface(m)
+             ENDDO
+
              DO  m = 1, surf_lsm_h%ns
                 i   = surf_lsm_h%i(m)            
Index: /palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/write_3d_binary.f90	(revision 2797)
+++ /palm/trunk/SOURCE/write_3d_binary.f90	(revision 2798)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Consider also default-type surfaces for surface temperature output. 
+! 
+! 2797 2018-02-08 13:24:35Z suehring
 ! Enable restarts for land- and urban-surface variables ghf_av, r_a_av and 
 ! tsurf_av.
@@ -390,7 +393,7 @@
           WRITE ( 14 )  'r_a_av              ';  WRITE ( 14 )  r_a_av
        ENDIF
-       IF ( ALLOCATED( tsurf_av ) )  THEN
-          WRITE ( 14 )  'tsurf_av            ';  WRITE ( 14 )  tsurf_av
-       ENDIF
+    ENDIF
+    IF ( ALLOCATED( tsurf_av ) )  THEN
+       WRITE ( 14 )  'tsurf_av            ';  WRITE ( 14 )  tsurf_av
     ENDIF
 