Index: palm/trunk/SCRIPTS/palm_gf
===================================================================
--- palm/trunk/SCRIPTS/palm_gf	(revision 2824)
+++ palm/trunk/SCRIPTS/palm_gf	(revision 2825)
@@ -1,3 +1,3 @@
-#!/usr/bin/python -B
+#!/usr/bin/env python
 # -*- coding: utf-8 -*-
 #--------------------------------------------------------------------------------#
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Modified header
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # Corrected "Former revisions" section
 # 
Index: palm/trunk/SCRIPTS/palm_jm
===================================================================
--- palm/trunk/SCRIPTS/palm_jm	(revision 2824)
+++ palm/trunk/SCRIPTS/palm_jm	(revision 2825)
@@ -1,3 +1,3 @@
-#!/usr/bin/python
+#!/usr/bin/env python
 # -*- coding: utf-8 -*-
 #--------------------------------------------------------------------------------#
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Modified header
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # Corrected "Former revisions" section
 # 
Index: palm/trunk/SCRIPTS/palm_wd
===================================================================
--- palm/trunk/SCRIPTS/palm_wd	(revision 2824)
+++ palm/trunk/SCRIPTS/palm_wd	(revision 2825)
@@ -1,3 +1,3 @@
-#!/usr/bin/python
+#!/usr/bin/env python
 # -*- coding: utf-8 -*-
 #--------------------------------------------------------------------------------#
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Modified header
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # Corrected "Former revisions" section
 # 
Index: palm/trunk/SCRIPTS/palm_wdd
===================================================================
--- palm/trunk/SCRIPTS/palm_wdd	(revision 2824)
+++ palm/trunk/SCRIPTS/palm_wdd	(revision 2825)
@@ -1,3 +1,3 @@
-#!/usr/bin/python
+#!/usr/bin/env python
 # -*- coding: utf-8 -*-
 #--------------------------------------------------------------------------------#
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Modified header
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # Corrected "Former revisions" section
 # 
Index: palm/trunk/SCRIPTS/palmrungui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui	(revision 2824)
+++ palm/trunk/SCRIPTS/palmrungui	(revision 2825)
@@ -1,3 +1,3 @@
-#!/usr/bin/python -B
+#!/usr/bin/env python
 # -*- coding: utf-8 -*-
 #--------------------------------------------------------------------------------#
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Adjusted to work with newest version of palmrun
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # Corrected "Former revisions" section
 # 
@@ -375,5 +378,4 @@
      
             if ( initialize == True ):#and self.group_runcontrol.isEnabled() == True ):
-                self.group_runcontrol.setEnabled(True)
                 self.group_execution.setEnabled(True)
                 self.group_job.findChild(QtGui.QComboBox,"drop_job").setEnabled(True)
@@ -383,5 +385,4 @@
             
             elif ( param[0] == ""):            
-                self.group_runcontrol.setEnabled(False)
                 self.group_execution.setEnabled(False)
                 self.group_job.findChild(QtGui.QComboBox,"drop_job").setEnabled(False)
@@ -430,6 +431,4 @@
                
                         
-                        
-                self.group_runcontrol.setEnabled(True)
                 self.group_execution.setEnabled(True)
                 self.drop_job.setEnabled(True)
@@ -438,14 +437,4 @@
         # Change in parameter "a" (run control list)
         elif (id_str == "a"): 
-            status_ts = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_ts").checkState()
-            status_pr = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_pr").checkState()
-            status_xy = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_xy").checkState()
-            status_xz = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_xz").checkState()
-            status_yz = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_yz").checkState()
-            status_3d = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_3d").checkState()
-            status_ma = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_ma").checkState()
-            status_sp = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_sp").checkState()
-            status_pts = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_pts").checkState()
-            status_prt = self.group_runcontrol.findChild(QtGui.QCheckBox,"check_prt").checkState()
     
             drop_job = self.group_job.findChild(QtGui.QComboBox,"drop_job").currentText()
@@ -472,34 +461,4 @@
             param[0] = "\"d3%s" % (rc_flag)
     
-            if (status_ts == 2):
-                param[0] = "%s ts%s" % (param[0],rc_flag)
-            
-            if (status_pr == 2):
-                param[0] = "%s pr%s" % (param[0],rc_flag)
-            
-            if (status_xy == 2):
-                param[0] = "%s xy%s" % (param[0],rc_flag)
-            
-            if (status_xz == 2):          
-                param[0] = "%s xz%s" % (param[0],rc_flag)
-            
-            if (status_yz == 2):    
-                param[0] = "%s yz%s" % (param[0],rc_flag)
-            
-            if (status_3d == 2):     
-                param[0] = "%s 3d%s" % (param[0],rc_flag)
-            
-            if (status_ma == 2):
-                param[0] = "%s ma%s" % (param[0],rc_flag)
-            
-            if (status_sp == 2):
-                param[0] = "%s sp%s" % (param[0],rc_flag)
-            
-            if (status_prt == 2):
-                param[0] = "%s prt%s" % (param[0],rc_flag)
-            
-            if (status_pts == 2):
-                param[0] = "%s pts%s" % (param[0],rc_flag)
-            
     
             if (drop_job == "Restart run (coupled atmosphere ocean)" or drop_job == "Initial run (coupled atmosphere ocean)"):
@@ -507,38 +466,8 @@
                    rc_flag = "o#"
                 else:
-                   rc_flag = "of"
+                   rc_flag = "or"
 
                 param[0] = "%s d3%s" % (param[0],rc_flag)
     
-                if (status_ts == 2):
-                    param[0] = "%s ts%s" % (param[0],rc_flag)
-                
-                if (status_pr == 2):                
-                    param[0] = "%s pr%s" % (param[0],rc_flag)
-                
-                if (status_xy == 2):
-                    param[0] = "%s xy%s" % (param[0],rc_flag)
-                
-                if (status_xz == 2):   
-                    param[0] = "%s xz%s" % (param[0],rc_flag)
-                
-                if (status_yz == 2):
-                    param[0] = "%s yz%s" % (param[0],rc_flag)
-                
-                if (status_3d == 2):
-                    param[0] = "%s 3d%s" % (param[0],rc_flag)
-                
-                if (status_ma == 2):
-                    param[0] = "%s ma%s" % (param[0],rc_flag)
-                
-                if (status_sp == 2):               
-                    param[0] = "%s sp%s" % (param[0],rc_flag)
-                
-                if (status_prt == 2):
-                    param[0] = "%s prt%s" % (param[0],rc_flag)
-                
-                if (status_pts == 2):
-                    param[0] = "%s pts%s" % (param[0],rc_flag)
-
             status_restarts = self.group_execution.findChild(QtGui.QCheckBox,"check_restarts").checkState()
 
@@ -563,8 +492,14 @@
     
             if (status_cycfill == 2):            
-                param[0]="%s cycfill" % (param[0])
+                param[0]="%s fill" % (param[0])
+            
+            status_svf = self.group_execution.findChild(QtGui.QCheckBox,"check_svf").checkState()
+    
+            if (status_svf == 2):            
+                param[0]="%s svf" % (param[0])
 
             param[0]="%s\"" % (param[0])
-    
+ 
+ 
             if ( fwt_str == "remove"):            
                 self.delete_commandline(id_str)
@@ -998,35 +933,5 @@
                     options_all = optionssplit[j] 
                     options_2 = optionssplit[j][:2] 
-                                      
-                    if (options_2 == "ts"):
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_ts").setChecked(True) 
-                    
-                    if (options_2 == "pr" and options_all[:3] is not "prt"):                  
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_pr").setChecked(True) 
-                    
-                    if (options_2 == "xy"):
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_xy").setChecked(True) 
-                    
-                    if (options_2 == "xz"):      
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_xz").setChecked(True) 
-                    
-                    if (options_2 == "yz"):     
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_yz").setChecked(True) 
-                    
-                    if (options_2 == "3d"):     
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_3d").setChecked(True) 
-                        
-                    if (options_2 == "ma"):             
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_ma").setChecked(True) 
-                    
-                    if (options_2 == "sp"):       
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_sp").setChecked(True) 
-                    
-                    if (options_all[:3] == "prt"):      
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_prt").setChecked(True) 
-                    
-                    if (options_all[:3] == "pts"):     
-                        self.group_runcontrol.findChild(QtGui.QCheckBox,"check_pts").setChecked(True) 
-                    
+                                              
                     if (options_2 == "d3"):      
                         if (options_all[:3][-1] == "#"):
@@ -1076,5 +981,4 @@
         if ( nojob == True ):
             self.group_execution.setEnabled(False) 
-            self.group_runcontrol.setEnabled(False) 
             self.groupBox.findChild(QtGui.QPushButton,"button_start").setEnabled(False) 
             self.menuBar.findChild(QtGui.QMenu,"menuStart").actions()[3].setEnabled(False) 
@@ -1085,5 +989,4 @@
         else:
             self.group_execution.setEnabled(True) 
-            self.group_runcontrol.setEnabled(True) 
             self.groupBox.findChild(QtGui.QPushButton,"button_start").setEnabled(True) 
             self.menuBar.findChild(QtGui.QMenu,"menuStart").actions()[3].setEnabled(True)
Index: palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui	(revision 2824)
+++ palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui	(revision 2825)
@@ -14,5 +14,5 @@
     <y>0</y>
     <width>600</width>
-    <height>655</height>
+    <height>700</height>
    </rect>
   </property>
@@ -26,5 +26,5 @@
    <size>
     <width>600</width>
-    <height>655</height>
+    <height>700</height>
    </size>
   </property>
@@ -32,5 +32,5 @@
    <size>
     <width>600</width>
-    <height>655</height>
+    <height>700</height>
    </size>
   </property>
@@ -67,5 +67,5 @@
      <rect>
       <x>0</x>
-      <y>550</y>
+      <y>570</y>
       <width>601</width>
       <height>81</height>
@@ -139,5 +139,5 @@
       <rect>
        <x>10</x>
-       <y>45</y>
+       <y>50</y>
        <width>581</width>
        <height>26</height>
@@ -167,5 +167,5 @@
       <y>5</y>
       <width>591</width>
-      <height>556</height>
+      <height>581</height>
      </rect>
     </property>
@@ -223,5 +223,5 @@
          <x>90</x>
          <y>30</y>
-         <width>221</width>
+         <width>481</width>
          <height>25</height>
         </rect>
@@ -262,5 +262,5 @@
          <x>10</x>
          <y>85</y>
-         <width>301</width>
+         <width>561</width>
          <height>181</height>
         </rect>
@@ -273,7 +273,7 @@
        <property name="geometry">
         <rect>
-         <x>10</x>
+         <x>70</x>
          <y>270</y>
-         <width>301</width>
+         <width>271</width>
          <height>25</height>
         </rect>
@@ -316,7 +316,7 @@
        <property name="geometry">
         <rect>
-         <x>320</x>
+         <x>350</x>
          <y>267</y>
-         <width>261</width>
+         <width>231</width>
          <height>31</height>
         </rect>
@@ -332,153 +332,25 @@
        </property>
       </widget>
-     </widget>
-     <widget class="QGroupBox" name="group_runcontrol">
-      <property name="enabled">
-       <bool>false</bool>
-      </property>
-      <property name="geometry">
-       <rect>
-        <x>320</x>
-        <y>0</y>
-        <width>251</width>
-        <height>281</height>
-       </rect>
-      </property>
-      <property name="title">
-       <string>Activation strings</string>
-      </property>
-      <property name="flat">
-       <bool>true</bool>
-      </property>
-      <widget class="QCheckBox" name="check_pr">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>45</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Profiles</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_3d">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>145</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>3D</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_xy">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>70</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>XY</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_ts">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>20</y>
-         <width>131</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Timeseries</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_ma">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>170</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Masks</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_sp">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>195</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Spectra</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_prt">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>220</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Particles</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_xz">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>95</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>XZ</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_yz">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>120</y>
-         <width>87</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>YZ</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_pts">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>240</y>
-         <width>151</width>
-         <height>36</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Particle timeseries</string>
-       </property>
-      </widget>
+      <widget class="QLabel" name="label_8">
+       <property name="geometry">
+        <rect>
+         <x>10</x>
+         <y>275</y>
+         <width>81</width>
+         <height>16</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Job type:</string>
+       </property>
+      </widget>
+      <zorder>line_jobname</zorder>
+      <zorder>pushButton</zorder>
+      <zorder>label</zorder>
+      <zorder>list_jobname</zorder>
+      <zorder>drop_job</zorder>
+      <zorder>label_usercode</zorder>
+      <zorder>palm_logo</zorder>
+      <zorder>label_8</zorder>
      </widget>
      <widget class="QGroupBox" name="group_execution">
@@ -491,5 +363,5 @@
         <y>305</y>
         <width>431</width>
-        <height>206</height>
+        <height>231</height>
        </rect>
       </property>
@@ -711,5 +583,5 @@
          <x>10</x>
          <y>140</y>
-         <width>271</width>
+         <width>281</width>
          <height>23</height>
         </rect>
@@ -738,7 +610,7 @@
        <property name="geometry">
         <rect>
-         <x>150</x>
+         <x>130</x>
          <y>120</y>
-         <width>421</width>
+         <width>291</width>
          <height>20</height>
         </rect>
@@ -765,4 +637,17 @@
        <property name="text">
         <string>Use cyclic fill method</string>
+       </property>
+      </widget>
+      <widget class="QCheckBox" name="check_svf">
+       <property name="geometry">
+        <rect>
+         <x>10</x>
+         <y>200</y>
+         <width>261</width>
+         <height>21</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Read sky view factors from file</string>
        </property>
       </widget>
@@ -1243,5 +1128,5 @@
      <y>0</y>
      <width>600</width>
-     <height>21</height>
+     <height>30</height>
     </rect>
    </property>
@@ -1251,6 +1136,6 @@
       <x>341</x>
       <y>82</y>
-      <width>133</width>
-      <height>182</height>
+      <width>128</width>
+      <height>189</height>
      </rect>
     </property>
@@ -1370,14 +1255,4 @@
   <tabstop>check_verbose</tabstop>
   <tabstop>check_cycfill</tabstop>
-  <tabstop>check_ts</tabstop>
-  <tabstop>check_pr</tabstop>
-  <tabstop>check_xy</tabstop>
-  <tabstop>check_xz</tabstop>
-  <tabstop>check_yz</tabstop>
-  <tabstop>check_3d</tabstop>
-  <tabstop>check_ma</tabstop>
-  <tabstop>check_sp</tabstop>
-  <tabstop>check_prt</tabstop>
-  <tabstop>check_pts</tabstop>
   <tabstop>button_start</tabstop>
   <tabstop>button_exit</tabstop>
@@ -1485,164 +1360,4 @@
   </connection>
   <connection>
-   <sender>check_ts</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>119</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>506</x>
-     <y>63</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_pr</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>144</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>506</x>
-     <y>90</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_xy</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>169</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>506</x>
-     <y>116</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_xz</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>194</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>505</x>
-     <y>142</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_yz</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>219</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>505</x>
-     <y>167</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_3d</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>244</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>505</x>
-     <y>194</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_ma</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>269</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>505</x>
-     <y>219</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_prt</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>319</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>505</x>
-     <y>247</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_sp</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>294</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>503</x>
-     <y>304</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>check_pts</sender>
-   <signal>stateChanged(int)</signal>
-   <receiver>MainWindow</receiver>
-   <slot>change_rc_list()</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>544</x>
-     <y>352</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>505</x>
-     <y>330</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
    <sender>drop_job</sender>
    <signal>currentIndexChanged(QString)</signal>
@@ -1667,6 +1382,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>72</x>
-     <y>536</y>
+     <x>76</x>
+     <y>527</y>
     </hint>
     <hint type="destinationlabel">
@@ -1683,6 +1398,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>76</x>
-     <y>561</y>
+     <x>80</x>
+     <y>547</y>
     </hint>
     <hint type="destinationlabel">
@@ -1699,6 +1414,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>57</x>
-     <y>584</y>
+     <x>61</x>
+     <y>567</y>
     </hint>
     <hint type="destinationlabel">
@@ -1719,5 +1434,5 @@
     </hint>
     <hint type="destinationlabel">
-     <x>954</x>
+     <x>599</x>
      <y>67</y>
     </hint>
@@ -1735,5 +1450,5 @@
     </hint>
     <hint type="destinationlabel">
-     <x>954</x>
+     <x>599</x>
      <y>103</y>
     </hint>
@@ -1751,5 +1466,5 @@
     </hint>
     <hint type="destinationlabel">
-     <x>956</x>
+     <x>599</x>
      <y>129</y>
     </hint>
@@ -1767,5 +1482,5 @@
     </hint>
     <hint type="destinationlabel">
-     <x>957</x>
+     <x>599</x>
      <y>158</y>
     </hint>
@@ -1783,5 +1498,5 @@
     </hint>
     <hint type="destinationlabel">
-     <x>955</x>
+     <x>599</x>
      <y>188</y>
     </hint>
@@ -1796,8 +1511,8 @@
     <hint type="sourcelabel">
      <x>434</x>
-     <y>289</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>955</x>
+     <y>282</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>255</y>
     </hint>
@@ -1811,6 +1526,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>123</x>
-     <y>421</y>
+     <x>127</x>
+     <y>434</y>
     </hint>
     <hint type="destinationlabel">
@@ -1827,6 +1542,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>99</x>
-     <y>472</y>
+     <x>124</x>
+     <y>459</y>
     </hint>
     <hint type="destinationlabel">
@@ -1843,6 +1558,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>183</x>
-     <y>496</y>
+     <x>187</x>
+     <y>484</y>
     </hint>
     <hint type="destinationlabel">
@@ -1859,6 +1574,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>342</x>
-     <y>422</y>
+     <x>346</x>
+     <y>435</y>
     </hint>
     <hint type="destinationlabel">
@@ -1875,6 +1590,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>365</x>
-     <y>446</y>
+     <x>369</x>
+     <y>484</y>
     </hint>
     <hint type="destinationlabel">
@@ -1891,6 +1606,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>334</x>
-     <y>472</y>
+     <x>344</x>
+     <y>460</y>
     </hint>
     <hint type="destinationlabel">
@@ -1907,9 +1622,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>644</x>
-     <y>102</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>954</x>
+     <x>304</x>
+     <y>330</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>328</y>
     </hint>
@@ -1923,9 +1638,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>754</x>
-     <y>192</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>955</x>
+     <x>414</x>
+     <y>380</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>396</y>
     </hint>
@@ -1939,9 +1654,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>754</x>
-     <y>282</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>955</x>
+     <x>414</x>
+     <y>405</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>522</y>
     </hint>
@@ -1955,9 +1670,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>754</x>
-     <y>371</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>956</x>
+     <x>414</x>
+     <y>446</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>612</y>
     </hint>
@@ -1971,9 +1686,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>754</x>
-     <y>416</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>955</x>
+     <x>414</x>
+     <y>479</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>650</y>
     </hint>
@@ -1987,9 +1702,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>307</x>
-     <y>652</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>956</x>
+     <x>299</x>
+     <y>654</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>689</y>
     </hint>
@@ -2003,9 +1718,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>754</x>
-     <y>132</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>953</x>
+     <x>414</x>
+     <y>355</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>599</x>
      <y>287</y>
     </hint>
@@ -2148,5 +1863,5 @@
     <hint type="sourcelabel">
      <x>434</x>
-     <y>314</y>
+     <y>307</y>
     </hint>
     <hint type="destinationlabel">
@@ -2164,5 +1879,5 @@
     <hint type="sourcelabel">
      <x>274</x>
-     <y>602</y>
+     <y>585</y>
     </hint>
     <hint type="destinationlabel">
@@ -2201,4 +1916,20 @@
      <x>458</x>
      <y>344</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>check_svf</sender>
+   <signal>stateChanged(int)</signal>
+   <receiver>MainWindow</receiver>
+   <slot>change_rc_list()</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>172</x>
+     <y>593</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>596</x>
+     <y>494</y>
     </hint>
    </hints>